
/** @file vdif_chk is test reading VDIF header data 
 *  @author M.Sekido
 * @Version $Rev: 56 $
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: test_chk.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include <iostream>
#include <string>
#include <vector>
using namespace std;

#include <cstdio>
#include <cstdlib>



#include "VDIF_Header.hpp"

//extern "C"{
#include <unistd.h>
//}

char *me;

void usage(){
  cerr << "Usage: " << me << " -f <filename> \n";
  //  cerr << "  -d <n>: Deltailed output level (default: 0)\n";
  exit(1);
}

int main(int argc, char *argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */

  string fname;
  //  if(argc < 2) usage();

  int k=0;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hf:")) { 
    case 'h':  usage(); break;
    case 'f':
      fname = optarg; 
      break;
      //    case 'd': vdif_hdr.Set_dbg(atoi(optarg)); break;
    case '?' : /* Error:  character not in list */ 
      fprintf(stderr, /* Yes */ 
	      "%s WARNING:  Unknown option on command line \n", me); 
      usage();
      break; 
    case ':' : /* Error:  missing parameter */ 
      fprintf(stderr, "%s WARNING:  Missing number on command line \n", me); 
      usage();
      break; 
    }
  }

  if(fname.empty()) usage();

  FILE *fp = fopen(fname.c_str(),"r");
  if(fp ==NULL){
    cerr << "Error in opening file: " << fname << endl;
    exit(1);
  }
  

  VDIF_Hdr vdifhdr[2], vdfh;
  int offset(0);
  int headsize = vdfh.Headsize();
  fprintf(stderr, "VDIF headsize=%lu %d\n", sizeof(vdif_hdr),
	   vdif_hdr.Headsize());
  
  VDIF_Hdr * pvdifhdr = VDIF_Hdr_find(fp,offset);
  int icnt=0;
  int jcnt=0;
  int32_t srate(-1);
  while(pvdifhdr !=0){
    vdfh = * pvdifhdr;
    if(pvdifhdr->iFrame() ==0){
      if(jcnt==0){
	vdifhdr[0] = *pvdifhdr; icnt=0; jcnt++;
      }else{
	vdifhdr[1] = *pvdifhdr;
	double dt = vdifhdr[1].Sec_Ref() - vdifhdr[0].Sec_Ref();
	double Mbps = (double)(icnt * vdifhdr[1].Framesize())/dt*8*1.e-6;
	srate = (int32_t)round(Mbps);
      }
    }      
     
    fprintf(stderr,"Hdr offset(%d) ",offset+headsize);
    vdfh.Print_hd(stderr);
    if(srate >0) fprintf(stderr," Estimated rate= %d Mbps.\n", srate);
     
    //    putc('\n',stderr);
    fseek(fp,headsize,SEEK_CUR);
    pvdifhdr = VDIF_Hdr_find(fp,offset);

    icnt++;
  }
  
  fclose(fp);
  
  
}

