/** 
 * @Author M.Sekido
 * @Version $Rev: 56 $
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: vdif2k5.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "VLBI_header.hpp"


char *me;

void usage(){
  cerr << "Usage: " << me << " -v <filename> -k <filename> -n <nch>\n";
  cerr << "  -v <fname>: VDIF File name.\n";
  cerr << "  -k <fname>: K5/VSSP32 File name.\n";
  cerr << "  -n <nch>  : Number of channels per one K5/VSSP file.\n";
  exit(1);
}

int main(int argc, char *argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */
  int k=0;
  string vdif_fname;  
  string k5_fname;
  VDIF_Header   vdif_hdr;
  

  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hv:k:n:")) { 
    case 'h':  usage(); break;
    case 'v': vdif_fname = optarg; break;
    case 'k': k5_fname = optarg; break;
    case 'n': nch = atoi(optarg); break;
      //    case 'd': vdif_hdr.Set_dbg(atoi(optarg)); break;
    case '?' : /* Error:  character not in list */ 
      fprintf(stderr, /* Yes */ 
	      "%s WARNING:  Unknown option on command line \n", me); 
      break; 
    case ':' : /* Error:  missing parameter */ 
      fprintf(stderr, "%s WARNING:  Missing number on command line \n", me); 
      usage();
      break; 
    }
  }
