
#include <iostream>
#include <cstdio>
using namespace std;

char *me;

void usage(){
  cerr << "Usage: " << me << " [-m <Bytes>]\n";
  cerr << " -m <MTU size> (default =1500)\n";
  exit(1);
}

void find(int mtu, int Mbps, int bit, int nch){
  mtu-=32;
  
  int32_t total = Mbps*1000000/8*bit*nch;
  fprintf(stderr, "%2dMbps/%dbit/%02dch (%ld kByte):",Mbps,bit,nch, total/1000);
  for(int ms=mtu; ms > 0; ms--){
    if( (total % ms) == 0 ){
      int nframe = total/ms;
      fprintf(stderr," %d:%d(%d)",ms+32, ms,nframe);
      if(ms % 8 ==0){
	fprintf(stderr," OK");
	break; 
      }
      putc(',',stderr);
    }
  }
  putc('\n',stderr);
}

main(int argc, char *argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  int nch_arr[4] = {1,4,8,16};
  int qbit_arr[4] = {1, 2, 4, 8 };
  int srate_arr[7] = {1, 2, 4, 8, 16, 32, 64};
  
  int mtu= 1500;
  int k=0;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hm:")) { 
    case 'h':   usage();     break;
    case 'm':  mtu= atoi(optarg); break;
    case '?':    usage(); break;
    }
  }
  

  for(int ich=0; ich<4; ich++){
    for(int jbit=0; jbit<4; jbit++){
      for(int is=0; is<7; is++){
	find(mtu, srate_arr[is], qbit_arr[jbit],nch_arr[ich]);
      }
    }
  }

}
